Object subclass: #Mickey1
	instanceVariableNames: 'form '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MVC-Study'!

!Mickey1 methodsFor: 'accessing' stamp: 'sumim 4/7/2019 16:24'!
form
	^form! !

!Mickey1 methodsFor: 'accessing' stamp: 'sumim 4/7/2019 16:24'!
form: aForm
	form _ aForm! !


!Mickey1 methodsFor: 'private' stamp: 'sumim 4/7/2019 21:05'!
setForm
	self form: (Form fromFileNamed: 'Mickey.form')! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Mickey1 class
	instanceVariableNames: ''!

!Mickey1 class methodsFor: 'instance creation' stamp: 'sumim 4/7/2019 16:28'!
new
	^super new setForm; yourself! !


!Mickey1 class methodsFor: 'examples' stamp: 'sumim 4/7/2019 16:48'!
example
	"Mickey1 example"
	| topView subView |
	topView _ StandardSystemView new.
	topView label: 'Mickey1'.
	topView borderWidth: 1.
	subView _ Mickey1View new.
	subView model: Mickey1 new.
	subView borderWidth: 1.
	subView insideColor: Color white.
	topView addSubView: subView.
	topView controller open! !


MouseMenuController subclass: #Mickey1Controller
	instanceVariableNames: ''
	classVariableNames: 'MickeyYellowButtonMenu MickeyYellowButtonMessages '
	poolDictionaries: ''
	category: 'MVC-Study'!

!Mickey1Controller methodsFor: 'initialize_release' stamp: 'sumim 4/7/2019 15:58'!
initialize
	super initialize.
	self initializeYellowButtonMenu! !

!Mickey1Controller methodsFor: 'initialize_release' stamp: 'sumim 4/7/2019 16:00'!
initializeYellowButtonMenu
	self yellowButtonMenu: MickeyYellowButtonMenu yellowButtonMessages: MickeyYellowButtonMessages! !


!Mickey1Controller methodsFor: 'control defaults' stamp: 'sumim 4/7/2019 16:02'!
isControlActive
	^sensor yellowButtonPressed! !


!Mickey1Controller methodsFor: 'menu messages' stamp: 'sumim 4/7/2019 16:58'!
magnify
	| mickeyForm |
	mickeyForm _ model form.
	model form: (mickeyForm magnify: mickeyForm boundingBox by: 2@2).
	view display! !

!Mickey1Controller methodsFor: 'menu messages' stamp: 'sumim 4/7/2019 16:58'!
shrink
	| mickeyForm |
	mickeyForm _ model form.
	model form: (mickeyForm magnify: mickeyForm boundingBox by: 0.5@0.5).
	view display! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Mickey1Controller class
	instanceVariableNames: ''!

!Mickey1Controller class methodsFor: 'class initialization' stamp: 'sumim 4/7/2019 16:13'!
initialize
	"Mickey1Controller initialize"
	| menuLabel |
	menuLabel _ 'magnify\shrink' withCRs.
	MickeyYellowButtonMenu _ PopUpMenu labels: menuLabel.
	MickeyYellowButtonMessages _ #(magnify shrink)! !


Mickey1Controller initialize!


View subclass: #Mickey1View
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MVC-Study'!

!Mickey1View methodsFor: 'controller access' stamp: 'sumim 4/7/2019 16:15'!
defaultControllerClass
	^Mickey1Controller! !


!Mickey1View methodsFor: 'displaying' stamp: 'sumim 4/7/2019 16:45'!
displayView
	| mickeyForm origin offset |
	mickeyForm _ model form.
	origin _ self insetDisplayBox origin.
	offset _ self insetDisplayBox extent - mickeyForm boundingBox extent // 2.
	mickeyForm
		displayOn: Display
		at: origin + offset
		clippingBox: self insetDisplayBox
		rule: Form over
		fillColor: nil! !


Object subclass: #Mickey2
	instanceVariableNames: 'form '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MVC-Study'!

!Mickey2 methodsFor: 'accessing' stamp: 'sumim 4/7/2019 17:12'!
form
	^form! !


!Mickey2 methodsFor: 'manipulation' stamp: 'sumim 4/7/2019 17:36'!
magnify
	form _ self form magnify: self form boundingBox by: 2@2.
	self changed: #magnify! !

!Mickey2 methodsFor: 'manipulation' stamp: 'sumim 4/7/2019 17:36'!
shrink
	form _ self form magnify: self form boundingBox by: 0.5@0.5.
	self changed: #shrink! !


!Mickey2 methodsFor: 'private' stamp: 'sumim 4/7/2019 17:36'!
setForm
	form _ Form fromFileNamed: 'Mickey.form'! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Mickey2 class
	instanceVariableNames: ''!

!Mickey2 class methodsFor: 'instance creation' stamp: 'sumim 4/7/2019 17:17'!
new
	^super new setForm; yourself! !


!Mickey2 class methodsFor: 'examples' stamp: 'sumim 4/7/2019 17:20'!
example
	"Mickey2 example"
	| topView subView |
	topView _ StandardSystemView new.
	topView label: 'Mickey2'.
	topView borderWidth: 1.
	subView _ Mickey2View new.
	subView model: Mickey2 new.
	subView borderWidth: 1.
	subView insideColor: Color white.
	topView addSubView: subView.
	topView controller open! !

!Mickey2 class methodsFor: 'examples' stamp: 'sumim 4/7/2019 21:55'!
example2
	"Mickey2 example2" "MODEL magnify"
	| topView subViewLeft subViewRight |
	Smalltalk at: #MODEL put: Mickey2 new.
	topView _ StandardSystemView new.
	topView label: 'Mickey2'.
	topView borderWidth: 1.
	subViewLeft _ Mickey2View new.
	subViewLeft model: MODEL.
	subViewLeft borderWidth: 1.
	subViewLeft insideColor: Color white.
	subViewRight _ Mickey2View new.
	subViewRight model: MODEL.
	subViewRight borderWidth: 1.
	subViewRight insideColor: Color white.
	topView addSubView: subViewLeft.
	topView addSubView: subViewRight toRightOf: subViewLeft.
	topView controller open
! !


MouseMenuController subclass: #Mickey2Controller
	instanceVariableNames: ''
	classVariableNames: 'MickeyYellowButtonMenu MickeyYellowButtonMessages '
	poolDictionaries: ''
	category: 'MVC-Study'!

!Mickey2Controller methodsFor: 'initialize-release ' stamp: 'sumim 4/7/2019 17:26'!
initialize
	super initialize.
	self initializeYellowButtonMenu! !

!Mickey2Controller methodsFor: 'initialize-release ' stamp: 'sumim 4/7/2019 17:27'!
initializeYellowButtonMenu
	self yellowButtonMenu: MickeyYellowButtonMenu yellowButtonMessages: MickeyYellowButtonMessages! !


!Mickey2Controller methodsFor: 'control defaults' stamp: 'sumim 4/7/2019 17:29'!
isControlActive
	^sensor yellowButtonPressed! !


!Mickey2Controller methodsFor: 'menu messages' stamp: 'sumim 4/7/2019 17:29'!
magnify
	model magnify! !

!Mickey2Controller methodsFor: 'menu messages' stamp: 'sumim 4/7/2019 17:29'!
shrink
	model shrink! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Mickey2Controller class
	instanceVariableNames: ''!

!Mickey2Controller class methodsFor: 'class initialization' stamp: 'sumim 4/7/2019 17:31'!
initialize
	"Mickey2Controller initialize"
	| menuLabel |
	menuLabel _ 'magnify\shrink' withCRs.
	MickeyYellowButtonMenu _ PopUpMenu labels: menuLabel.
	MickeyYellowButtonMessages _ #(magnify shrink)! !


Mickey2Controller initialize!


View subclass: #Mickey2View
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MVC-Study'!

!Mickey2View methodsFor: 'controller accesss' stamp: 'sumim 4/7/2019 17:23'!
defaultControllerClass
	^Mickey2Controller! !


!Mickey2View methodsFor: 'displaying' stamp: 'sumim 4/7/2019 17:24'!
displayView
	| mickeyForm origin offset |
	mickeyForm _ model form.
	origin _ self insetDisplayBox origin.
	offset _ self insetDisplayBox extent - mickeyForm boundingBox extent // 2.
	mickeyForm
		displayOn: Display
		at: origin + offset
		clippingBox: self insetDisplayBox
		rule: Form over
		fillColor: nil! !


!Mickey2View methodsFor: 'updating' stamp: 'sumim 4/7/2019 17:25'!
update: parameter
	self display! !


Object subclass: #Mickey3
	instanceVariableNames: 'form '
	classVariableNames: 'MickeyMenu '
	poolDictionaries: ''
	category: 'MVC-Study'!

!Mickey3 methodsFor: 'accessing' stamp: 'sumim 4/7/2019 17:39'!
form
	^form! !

!Mickey3 methodsFor: 'accessing' stamp: 'sumim 4/7/2019 17:44'!
menu
	^MickeyMenu ifNil: [
		MickeyMenu _ SelectionMenu selections: #(magnify shrink)
	]! !


!Mickey3 methodsFor: 'manipulation' stamp: 'sumim 4/7/2019 17:45'!
magnify
	form _ self form magnify: self form boundingBox by: 2@2.
	self changed: #magnify! !

!Mickey3 methodsFor: 'manipulation' stamp: 'sumim 4/7/2019 17:45'!
shrink
	form _ self form magnify: self form boundingBox by: 0.5@0.5.
	self changed: #shrink! !


!Mickey3 methodsFor: 'private' stamp: 'sumim 4/7/2019 17:48'!
setForm
	form _ Form fromFileNamed: 'Mickey.form'! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Mickey3 class
	instanceVariableNames: ''!

!Mickey3 class methodsFor: 'class initialization' stamp: 'sumim 4/7/2019 17:49'!
flushMenus
	"Mickey3 flushMenus"
	MickeyMenu _ nil! !


!Mickey3 class methodsFor: 'inatance creation' stamp: 'sumim 4/7/2019 17:49'!
new
	^super new setForm; yourself! !


!Mickey3 class methodsFor: 'examples' stamp: 'sumim 4/7/2019 20:53'!
example
	"Mickey3 example"
	| topView subView |
	topView _ StandardSystemView new.
	topView label: 'Mickey3'.
	topView borderWidth: 1.
	subView _ Mickey3View on: Mickey3 new aspect: #form menu: #menu.
	subView borderWidth: 1.
	subView insideColor: Color white.
	topView addSubView: subView.
	topView controller open! !


MouseMenuController subclass: #Mickey3Controller
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MVC-Study'!

!Mickey3Controller methodsFor: 'control defaults' stamp: 'sumim 4/7/2019 18:16'!
isControlActive
	^sensor yellowButtonPressed! !


!Mickey3Controller methodsFor: 'control activity' stamp: 'sumim 4/7/2019 21:00'!
yellowButtonActivity
	| menu selector |
	menu _ view yellowButtonMenu.
	selector _ menu startUp.

	selector ifNotNil: [
		self controlTerminate.
		model perform: selector.
		self controlInitialize
	]! !


View subclass: #Mickey3View
	instanceVariableNames: 'aspectSelector menuSelector '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MVC-Study'!

!Mickey3View methodsFor: 'controller access' stamp: 'sumim 4/7/2019 18:09'!
defaultControllerClass
	^Mickey3Controller! !


!Mickey3View methodsFor: 'displaying' stamp: 'sumim 4/7/2019 18:10'!
displayView
	| mickeyForm origin offset |
	mickeyForm _ model perform: aspectSelector.
	origin _ self insetDisplayBox origin.
	offset _ self insetDisplayBox extent - mickeyForm boundingBox extent // 2.
	mickeyForm
		displayOn: Display
		at: origin + offset
		clippingBox: self insetDisplayBox
		rule: Form over
		fillColor: nil! !


!Mickey3View methodsFor: 'updating' stamp: 'sumim 4/7/2019 18:12'!
update: parameter
	self display! !


!Mickey3View methodsFor: 'private' stamp: 'sumim 4/7/2019 20:56'!
on: aModel aspect: aspect menu: menu
	self model: aModel.
	aspectSelector _ aspect.
	menuSelector _ menu! !

!Mickey3View methodsFor: 'private' stamp: 'sumim 4/7/2019 18:14'!
yellowButtonMenu
	^model perform: menuSelector! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Mickey3View class
	instanceVariableNames: ''!

!Mickey3View class methodsFor: 'instance creation' stamp: 'sumim 4/7/2019 18:15'!
on: model aspect: aspect menu: menu
	^self new on: model aspect: aspect menu: menu; yourself! !
